# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::Mgmt::V2018_02_01
  module Models
    #
    # Defines a delta health policy used to evaluate the health of an
    # application or one of its child entities when upgrading the cluster.
    #
    #
    class ApplicationDeltaHealthPolicy

      include MsRestAzure

      # @return [ServiceTypeDeltaHealthPolicy] The delta health policy used by
      # default to evaluate the health of a service type when upgrading the
      # cluster.
      attr_accessor :default_service_type_delta_health_policy

      # @return [Hash{String => ServiceTypeDeltaHealthPolicy}] The map with
      # service type delta health policy per service type name. The map is
      # empty by default.
      attr_accessor :service_type_delta_health_policies


      #
      # Mapper for ApplicationDeltaHealthPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApplicationDeltaHealthPolicy',
          type: {
            name: 'Composite',
            class_name: 'ApplicationDeltaHealthPolicy',
            model_properties: {
              default_service_type_delta_health_policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'defaultServiceTypeDeltaHealthPolicy',
                type: {
                  name: 'Composite',
                  class_name: 'ServiceTypeDeltaHealthPolicy'
                }
              },
              service_type_delta_health_policies: {
                client_side_validation: true,
                required: false,
                serialized_name: 'serviceTypeDeltaHealthPolicies',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ServiceTypeDeltaHealthPolicyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ServiceTypeDeltaHealthPolicy'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
